	#tag Class
	Protected Class Message
		#tag Method, Flags = &h0
			Sub AddParam(Value As Variant)
			  // less than preferred method, tries to guess
			  
			  dim type as string = GuessType(value)
			  select case type
			  case kDataType_Array
			    self.AddParam_Array value
			  case kDataType_Boolean
			    self.AddParam_Boolean value.booleanvalue
			  case kDataType_Date
			    self.AddParam_Date value.datevalue
			  case kDataType_Double
			    self.AddParam_Double value.doublevalue
			  case kDataType_Integer, kDataType_Integer4
			    self.AddParam_Integer value.integervalue
			  case kDataType_Dictionary
			    self.AddParam_Dictionary dictionary(value.objectvalue)
			  case kDataType_String
			    self.AddParam_String value.stringvalue
			  end
			End Sub
		#tag EndMethod

		#tag Method, Flags = &h0
			Sub AddParam_Array(Values() As Variant)
			  Params.Append kDataType_Array : values
			End Sub
		#tag EndMethod

		#tag Method, Flags = &h0
			Sub AddParam_Boolean(Value As Boolean)
			  params.append kDataType_Boolean : value
			End Sub
		#tag EndMethod

		#tag Method, Flags = &h0
			Sub AddParam_String(Value As String)
			  params.append kDataType_String : value
			End Sub
		#tag EndMethod

		#tag Method, Flags = &h0
			Sub AddParam_Date(Value As Date)
			  params.append kDataType_Date : value
			End Sub
		#tag EndMethod

		#tag Method, Flags = &h0
			Sub AddParam_Dictionary(Value As Dictionary)
			  params.append kDataType_Dictionary : value
			End Sub
		#tag EndMethod

		#tag Method, Flags = &h0
			Sub AddParam_Double(Value As Double)
			  params.append kDataType_Double : value
			End Sub
		#tag EndMethod

		#tag Method, Flags = &h0
			Sub AddParam_Integer(Value As Integer)
			  params.append kDataType_Integer : value
			End Sub
		#tag EndMethod

		#tag Method, Flags = &h0
			Sub AddParam_Binary(Value As String)
			  params.append kDataType_Binary : encodebase64(value)
			End Sub
		#tag EndMethod

		#tag Method, Flags = &h0
			Sub Constructor()
			  // does nothing
			End Sub
		#tag EndMethod

		#tag Method, Flags = &h0
			Sub Constructor(inMethodName As String)
			  self.constructor
			  self.methodname = inmethodname
			End Sub
		#tag EndMethod

		#tag Method, Flags = &h0
			Function Serialize() As String
			  dim xmldoc as new xmldocument
			  xmldoc.preservewhitespace = true
			  
			  dim root,name,params,param,value as xmlelement
			  dim i as integer
			  
			  root = xmldoc.createelement("methodCall")
			  name = xmldoc.createelement("methodName")
			  name.appendchild xmldoc.createtextnode(me.methodname)
			  params = xmldoc.createelement("params")
			  for i = 0 to ubound(me.params)
			    param = xmldoc.createelement("param")
			    value = xmldoc.createelement("value")
			    value.appendchild encode(me.params(i),xmldoc)
			    param.appendchild value
			    params.appendchild param
			  next
			  root.appendchild name
			  root.appendchild params
			  xmldoc.appendchild root
			  
			  return xmldoc.tostring
			exception err as xmlexception
			  break
			End Function
		#tag EndMethod


		#tag Property, Flags = &h21
			Private Params(-1) As Pair
		#tag EndProperty

		#tag Property, Flags = &h0
			MethodName As String
		#tag EndProperty


		#tag ViewBehavior
			#tag ViewProperty
				Name="Name"
				Visible=true
				Group="ID"
				InheritedFrom="Object"
			#tag EndViewProperty
			#tag ViewProperty
				Name="Index"
				Visible=true
				Group="ID"
				InitialValue="2147483648"
				InheritedFrom="Object"
			#tag EndViewProperty
			#tag ViewProperty
				Name="Super"
				Visible=true
				Group="ID"
				InheritedFrom="Object"
			#tag EndViewProperty
			#tag ViewProperty
				Name="Left"
				Visible=true
				Group="Position"
				InitialValue="0"
				InheritedFrom="Object"
			#tag EndViewProperty
			#tag ViewProperty
				Name="Top"
				Visible=true
				Group="Position"
				InitialValue="0"
				InheritedFrom="Object"
			#tag EndViewProperty
			#tag ViewProperty
				Name="MethodName"
				Group="Behavior"
				Type="String"
				EditorType="MultiLineEditor"
			#tag EndViewProperty
		#tag EndViewBehavior
	End Class
	#tag EndClass
